import 'package:flutter/material.dart';

class Badge extends StatelessWidget{
  final Key key;

  final EdgeInsets _padding;
  final Radius _radius;
  final Color _badgeColor;

  final String _text;
  final TextStyle _textStyle;

  final InlineSpan textSpan;
  final TextStyle style;
  final StrutStyle strutStyle;
  final TextAlign textAlign;
  final TextDirection textDirection;
  final Locale locale;
  final bool softWrap;
  final TextOverflow overflow;
  final double textScaleFactor;
  final int maxLines;
  final String semanticsLabel;
  final TextWidthBasis textWidthBasis;
  final Text textView;

  Badge({
    this.key,
    String text,
    Color badgeColor,
    Color textColor,
    double fontSize,
    EdgeInsets padding,
    Radius radius,
    TextStyle textStyle,
    this.textSpan,
    this.style,
    this.strutStyle,
    this.textAlign,
    this.textDirection,
    this.locale,
    this.softWrap,
    this.overflow,
    this.textScaleFactor,
    this.maxLines,
    this.semanticsLabel,
    this.textWidthBasis,
    this.textView,
  }) :
    _badgeColor = badgeColor ?? Colors.blue,
    _textStyle = textStyle ?? TextStyle(color: textColor ?? Colors.white, fontSize: fontSize ?? 10),
    _padding = padding ?? EdgeInsets.only(top: 2, right: 4, bottom: 2, left: 4),
    _radius = radius ?? Radius.circular(8),
    _text = text ?? ""
  ;

  @override
  Widget build(BuildContext context) =>
    Container(
      padding: _padding,
      decoration: BoxDecoration(
          color: _badgeColor,
          borderRadius: BorderRadius.all(_radius),
      ),
      child: textView ?? Text(
        _text,
        maxLines: maxLines,
        style: _textStyle,
        strutStyle: strutStyle,
        textAlign: textAlign,
        textDirection: textDirection,
        locale: locale,
        softWrap: softWrap,
        overflow: overflow,
        textScaleFactor: textScaleFactor,
        semanticsLabel: semanticsLabel,
        textWidthBasis: textWidthBasis,
      ),
    );
}